#146 TS Session Broker support

v1.8.2
closed
None
5
2014-05-21
2010-03-10
Anonymous
No

I suggest there is no track for the feature request about Windows 2008 TS Session Broker support, am I right?
The main request is to redirect connections. I reviewed the repo, tried some revisions, mostly hoped for r1563. But the session halts on redirection.

Related

Feature Requests: #146

Discussion


  • Anonymous
    2010-05-11

    Is there some update concerning this ?

     

  • Anonymous
    2010-05-25

    Is someone taking this up ? I'm really stuck with that Connection Broker thing ... :-(

     
  • Yeah, we're here in Garden Route, South Africa and we are having quite the tough time getting a work around going.

    Any update on this? We will test and provide feedback very quickly.

    R

     
  • Ola Magnusson
    Ola Magnusson
    2011-03-08

    I'm also wondering if someone can look into this?

     

  • Anonymous
    2011-08-30

    I am also interested in this feature. I just recently discovered the RDP over HTTPS feature using my company's Terminal Server running Windows Server 2008. I'd like to be able to use this from Linux

     

  • Anonymous
    2012-11-07

    Please see: https://sourceforge.net/tracker/?func=detail&aid=3575645&group_id=24366&atid=381349 (tracker patch 3575645). We use these patches since few weeks with success. .. (but have not got any reply from rdesktop developers about ...)

    Cheers

    Jarek

     
  • The server redirection has been rewritten and verified against 2003 and 2008r2 using session directory / broker.

     
    • Group: --> NextRelease
     
  • leeyiw
    leeyiw
    2013-12-06

    redirect connecton failed when server redirection PDU doesn't contains flag: LB_TARGET_NET_ADDRESS(0x00000001) and doesn't contains field: TargetNetAddress. The mstsc.exe in Windows will reconnect to the server which send this redirection PDU. And I think rdesktop should behave the same way. The quickly fix in rdp.c is:
    1497a1498,1499
    > } else {
    > g_redirect_server[0] = '\0';
    in rdesktop.c:
    1118c1118,1120
    < STRNCPY(server, g_redirect_server, sizeof(server));
    ---
    > if (g_redirect_server[0] != '\0') {
    > STRNCPY(server, g_redirect_server, sizeof(server));
    > }

     
    Last edit: leeyiw 2013-12-06
    • it does feel strange that you would receive a redirection PDU wihout information about the target you should connect to. Did you get the warning in console about PDU_REDIRECT_HAS_TARGET_NETBIOS or alike ?

      Could you apply this patch and send me redirect_pdu.raw, be aware that your password would be plain text in this packet dump:

      Index: rdp.c
      ===================================================================
      --- rdp.c   (revision 1773)
      +++ rdp.c   (working copy)
      @@ -1534,6 +1534,10 @@
          g_redirect_lb_info = NULL;
          g_redirect_cookie = NULL;
      
      +   FILE *f = fopen("redirect_pdu.raw", "wb");
      +   fwrite(s->p, 1, (s->end - s->p) ,f);
      +   fclose(f);
      +
          /* these 2 bytes are unknown, seem to be zeros */
          in_uint8s(s, 2);
      
       
      Last edit: Henrik Andersson 2013-12-09
      • leeyiw
        leeyiw
        2013-12-06

        I think the reason the redirection PDU doesn't contain TargetNetAddress is
        because there is a NAT between RDP client and server, and this field is
        optional in the RDP protocol. I will send you a redirect_pdu.raw on monday.
        and because the RDP protocol document doesn't describe this scenario,
        rdesktop should behave like mstsc.exe.

        2013/12/6 Henrik Andersson hean01@users.sf.net

        it does feel strange that you would receive a redirection PDU wihout
        information about the target you should connect to. Did you get the warning
        in console about PDU_REDIRECT_HAS_TARGET_NETBIOS or alike ?

        Could you apply this patch and send me redirect_pdu.raw, be aware that
        your password would be plain text in this packet dump:
        Index: rdp.c

        --- rdp.c (revision 1773)
        +++ rdp.c (working copy)
        @@ -1534,6 +1534,10 @@
        g_redirect_lb_info = NULL;
        g_redirect_cookie = NULL;

        • FILE *f = fopen("redirect_pdu.raw", "wb");
        • fwrite(s->p, 1, (s->end - s->p) ,f);
        • fclose(f);
          +
          / these 2 bytes are unknown, seem to be zeros /
          in_uint8s(s, 2);

        Status: open
        Created: Wed Mar 10, 2010 09:09 AM UTC by Anonymous
        Last Updated: Fri Dec 06, 2013 03:44 AM UTC
        Owner: nobody

        I suggest there is no track for the feature request about Windows 2008 TS
        Session Broker support, am I right?
        The main request is to redirect connections. I reviewed the repo, tried
        some revisions, mostly hoped for r1563. But the session halts on
        redirection.


        Sent from sourceforge.net because you indicated interest in
        https://sourceforge.net/p/rdesktop/feature-requests/146/

        To unsubscribe from further messages, please visit
        https://sourceforge.net/auth/subscriptions/

         

        Related

        Feature Requests: #146

        • leeyiw
          leeyiw
          2013-12-06

          and I'm not get any warning in console when receive the redirection PDU

          2013/12/6 李毅为 leeyiw@gmail.com

          I think the reason the redirection PDU doesn't contain TargetNetAddress
          is because there is a NAT between RDP client and server, and this field is
          optional in the RDP protocol. I will send you a redirect_pdu.raw on
          monday. and because the RDP protocol document doesn't describe this
          scenario, rdesktop should behave like mstsc.exe.

          2013/12/6 Henrik Andersson hean01@users.sf.net

          it does feel strange that you would receive a redirection PDU wihout
          information about the target you should connect to. Did you get the warning
          in console about PDU_REDIRECT_HAS_TARGET_NETBIOS or alike ?

          Could you apply this patch and send me redirect_pdu.raw, be aware that
          your password would be plain text in this packet dump:
          Index: rdp.c

          --- rdp.c (revision 1773)
          +++ rdp.c (working copy)
          @@ -1534,6 +1534,10 @@
          g_redirect_lb_info = NULL;
          g_redirect_cookie = NULL;

          • FILE *f = fopen("redirect_pdu.raw", "wb");
          • fwrite(s->p, 1, (s->end - s->p) ,f);
          • fclose(f);
            +
            / these 2 bytes are unknown, seem to be zeros /
            in_uint8s(s, 2);

          Status: open
          Created: Wed Mar 10, 2010 09:09 AM UTC by Anonymous
          Last Updated: Fri Dec 06, 2013 03:44 AM UTC
          Owner: nobody

          I suggest there is no track for the feature request about Windows 2008 TS
          Session Broker support, am I right?
          The main request is to redirect connections. I reviewed the repo, tried
          some revisions, mostly hoped for r1563. But the session halts on
          redirection.


          Sent from sourceforge.net because you indicated interest in
          https://sourceforge.net/p/rdesktop/feature-requests/146/

          To unsubscribe from further messages, please visit
          https://sourceforge.net/auth/subscriptions/

           

          Related

          Feature Requests: #146

          • leeyiw
            leeyiw
            2013-12-11

            Sorry, I'm late.

            Here is the redirect_pdu.raw, It looks like it's only contains a redirect
            session ID and the username and passwod

            2013/12/6 leeyiw leeyiw@users.sf.net

            and I'm not get any warning in console when receive the redirection PDU

            2013/12/6 李毅为 leeyiw@gmail.com

            I think the reason the redirection PDU doesn't contain TargetNetAddress

            is because there is a NAT between RDP client and server, and this field is
            optional in the RDP protocol. I will send you a redirect_pdu.raw on
            monday. and because the RDP protocol document doesn't describe this
            scenario, rdesktop should behave like mstsc.exe.

            2013/12/6 Henrik Andersson hean01@users.sf.net

            it does feel strange that you would receive a redirection PDU wihout
            information about the target you should connect to. Did you get the warning
            in console about PDU_REDIRECT_HAS_TARGET_NETBIOS or alike ?

            Could you apply this patch and send me redirect_pdu.raw, be aware that
            your password would be plain text in this packet dump:
            Index: rdp.c

            --- rdp.c (revision 1773)
            +++ rdp.c (working copy)
            @@ -1534,6 +1534,10 @@
            g_redirect_lb_info = NULL;
            g_redirect_cookie = NULL;

            • FILE *f = fopen("redirect_pdu.raw", "wb");
            • fwrite(s->p, 1, (s->end - s->p) ,f);
            • fclose(f);
              +
              / these 2 bytes are unknown, seem to be zeros /
              in_uint8s(s, 2);

            Status: open
            Created: Wed Mar 10, 2010 09:09 AM UTC by Anonymous
            Last Updated: Fri Dec 06, 2013 03:44 AM UTC
            Owner: nobody

            I suggest there is no track for the feature request about Windows 2008 TS
            Session Broker support, am I right?
            The main request is to redirect connections. I reviewed the repo, tried
            some revisions, mostly hoped for r1563. But the session halts on
            redirection.


            Sent from sourceforge.net because you indicated interest in
            https://sourceforge.net/p/rdesktop/feature-requests/146/

            To unsubscribe from further messages, please visit
            https://sourceforge.net/auth/subscriptions/


            [feature-requests:#146]
            http://sourceforge.net/p/rdesktop/feature-requests/146/ TS Session Broker
            support

            Status: open
            Created: Wed Mar 10, 2010 09:09 AM UTC by Anonymous
            Last Updated: Fri Dec 06, 2013 03:44 AM UTC
            Owner: nobody

            I suggest there is no track for the feature request about Windows 2008 TS
            Session Broker support, am I right?
            The main request is to redirect connections. I reviewed the repo, tried
            some revisions, mostly hoped for r1563. But the session halts on
            redirection.


            Sent from sourceforge.net because you indicated interest in
            https://sourceforge.net/p/rdesktop/feature-requests/146/

            To unsubscribe from further messages, please visit
            https://sourceforge.net/auth/subscriptions/

             
    • status: open --> closed
    • assigned_to: Henrik Andersson
     
  • Support for server redirection using TS Session Broker (2008 / 2012) is now implemented and extensively tested. However rdesktop does not support connecting to a farm using RDS gateway.

     
    • leeyiw
      leeyiw
      2014-05-22

      I found that 1.8.2 is released. but still didn't handle correct when g_redirect_flags didn't contain PDU_REDIRECT_HAS_IP. can it be fixed in next version? I can upload an patch

       
      • Hi,

        Yes, could you please create a new bug describing the use-case and attach the patch. I'm not sure how to fix your issue, seems like it's about implementing a new feature, RDS gateway support.

         
        • leeyiw
          leeyiw
          2014-05-23

          Hi,

          I have create a new bug [bugs:#385] and the patch is tested work perfectly on my computer. Please take a look at it, Thanks.

           

          Related

          Bugs: #385